function love.load()
	enabled = false
	image = love.graphics.newImage("image.png")
	captionTimer = 0

	translate = {x=0, y=0}
	scene = {}
	scene.width = 2048
	scene.height = 2048

	-- Iniitialize canvas
	canvas = love.graphics.newCanvas(scene.width, scene.height)

	-- Create random objects placed everywhere
	imageSet = {}
	for i = 1, 10000 do
		local entry = {}
		entry.x = math.random(scene.width-128)
		entry.y = math.random(scene.height-128)
		imageSet[i] = entry
	end

	-- Draw them to the canvas
	love.graphics.setRenderTarget(canvas)
	for _, v in ipairs(imageSet) do
		love.graphics.draw(image, v.x, v.y)
	end
	love.graphics.setRenderTarget()
end


function love.update(dt)
	captionTimer = captionTimer + dt

	if love.keyboard.isDown("left") then
		translate.x = translate.x + 1000*dt
	elseif love.keyboard.isDown("right") then
		translate.x = translate.x - 1000*dt
	end

	if love.keyboard.isDown("up") then
		translate.y = translate.y + 1000*dt
	elseif love.keyboard.isDown("down") then
		translate.y = translate.y - 1000*dt
	end
end

function love.draw()
	love.graphics.push()
	love.graphics.translate(translate.x, translate.y)

	if enabled then
		-- Switch to premultiplied blending because the image has already been alpha-blended to the canvas.
		love.graphics.setBlendMode("premultiplied")
		love.graphics.draw(canvas, 0, 0)
		love.graphics.setBlendMode("alpha")
	else
		for _, v in ipairs(imageSet) do
			love.graphics.draw(image, v.x, v.y)
		end
	end
	love.graphics.pop()

	if captionTimer > 0.1 then
		captionTimer = captionTimer - 0.1

		fps = love.timer.getFPS()
		if enabled then
			love.graphics.setCaption(fps.." Canvas rendering enabled", 0, 0)
		else
			love.graphics.setCaption(fps.." Canvas rendering disabled", 0, 0)
		end
	end
end

function love.keypressed(k)
	if k == " " then
		enabled = not enabled
	elseif k == "escape" then
		love.event.quit()
	end
end
